VERSION 5.00
Begin VB.UserControl KalDayCell 
   Appearance      =   0  'Flat
   CanGetFocus     =   0   'False
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   390
   KeyPreview      =   -1  'True
   ScaleHeight     =   285
   ScaleWidth      =   390
   ToolboxBitmap   =   "KalDayCell.ctx":0000
   Windowless      =   -1  'True
   Begin VB.Shape shpBorder 
      BorderColor     =   &H80000015&
      Height          =   255
      Left            =   0
      Top             =   0
      Width           =   375
   End
   Begin VB.Line linBottomHoriz 
      Visible         =   0   'False
      X1              =   60
      X2              =   300
      Y1              =   180
      Y2              =   180
   End
   Begin VB.Line linRightVert 
      Visible         =   0   'False
      X1              =   300
      X2              =   300
      Y1              =   60
      Y2              =   240
   End
   Begin VB.Line linTopHoriz 
      Visible         =   0   'False
      X1              =   60
      X2              =   300
      Y1              =   60
      Y2              =   60
   End
   Begin VB.Line linLeftVert 
      Visible         =   0   'False
      X1              =   60
      X2              =   60
      Y1              =   300
      Y2              =   60
   End
   Begin VB.Label lblValue 
      Caption         =   "1"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   255
   End
End
Attribute VB_Name = "KalDayCell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'==========
'KalDayCell
'==========
'
'Part of Kal:
'
'A replacement for the MSCAL.OCX Calendar control, written in 100% VB.
'
'If compiled into an OCX, this control would not be a Public member
'(would not be visible to clients).
'

Public Enum DAYCELLEFFECTS
    ccdcEffectFlat = 0
    ccdcEffectRaised = 1
    ccdcEffectSunken = 2
End Enum
#If False Then
Dim ccdcEffectFlat, ccdcEffectRaised, ccdcEffectSunken
#End If

Private mEffect As DAYCELLEFFECTS
Private WithEvents mFont As StdFont
Attribute mFont.VB_VarHelpID = -1
Private mFontColor As OLE_COLOR
Private mFontPressedColor As OLE_COLOR
Private mLinesColor As OLE_COLOR
Private mPressed As Boolean
Private mPressedColor As OLE_COLOR
Private mValue As Integer

Public Event Click()
Public Event KeyDown(ByRef KeyCode As Integer, ByRef Shift As Integer)

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal RHS As OLE_COLOR)
    UserControl.BackColor = RHS
    lblValue.BackColor = RHS
    PropertyChanged "BackColor"
End Property

Public Property Get Effect() As DAYCELLEFFECTS
Attribute Effect.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Effect = mEffect
End Property

Public Property Let Effect(ByVal RHS As DAYCELLEFFECTS)
    If ccdcEffectFlat > RHS Or RHS > ccdcEffectSunken Then RHS = ccdcEffectFlat
    mEffect = RHS
    If mEffect = ccdcEffectSunken Then
        linLeftVert.BorderColor = vb3DHighlight
        linTopHoriz.BorderColor = vb3DHighlight
        linRightVert.BorderColor = vb3DDKShadow
        linBottomHoriz.BorderColor = vb3DDKShadow
    ElseIf mEffect = ccdcEffectRaised Then
        linLeftVert.BorderColor = vb3DDKShadow
        linTopHoriz.BorderColor = vb3DDKShadow
        linRightVert.BorderColor = vb3DHighlight
        linBottomHoriz.BorderColor = vb3DHighlight
    End If
    linLeftVert.Visible = mEffect <> ccdcEffectFlat
    linTopHoriz.Visible = linLeftVert.Visible
    linRightVert.Visible = linLeftVert.Visible
    linBottomHoriz.Visible = linLeftVert.Visible
    Pressed = Pressed
    PropertyChanged "Effect"
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
   Set Font = mFont
End Property

Public Property Set Font(ByVal RHS As StdFont)
   With mFont
      .Bold = RHS.Bold
      .Charset = RHS.Charset
      .Italic = RHS.Italic
      .Name = RHS.Name
      .Size = RHS.Size
      .Strikethrough = RHS.Strikethrough
      .Underline = RHS.Underline
      .Weight = RHS.Weight
   End With
   PropertyChanged "Font"
End Property

Public Property Get FontColor() As OLE_COLOR
Attribute FontColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    FontColor = mFontColor
End Property

Public Property Let FontColor(ByVal RHS As OLE_COLOR)
    mFontColor = RHS
    If Not mPressed Then lblValue.ForeColor = RHS
    PropertyChanged "FontColor"
End Property

Public Property Get FontPressedColor() As OLE_COLOR
Attribute FontPressedColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    FontPressedColor = mFontPressedColor
End Property

Public Property Let FontPressedColor(ByVal RHS As OLE_COLOR)
    mFontPressedColor = RHS
    If mPressed Then lblValue.ForeColor = RHS
    PropertyChanged "FontPressedColor"
End Property

Public Property Get LinesColor() As OLE_COLOR
Attribute LinesColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    LinesColor = mLinesColor
End Property

Public Property Let LinesColor(ByVal RHS As OLE_COLOR)
    mLinesColor = RHS
    shpBorder.BorderColor = RHS
    PropertyChanged "LinesColor"
End Property

Public Property Get Pressed() As Boolean
Attribute Pressed.VB_ProcData.VB_Invoke_Property = ";Data"
    Pressed = mPressed
End Property

Public Property Let Pressed(ByVal RHS As Boolean)
    mPressed = RHS
    If mPressed Then
        BackColor = mPressedColor
        lblValue.BackColor = mPressedColor
        lblValue.ForeColor = mFontPressedColor
        If mEffect <> ccdcEffectFlat Then
            linLeftVert.Visible = True
            linTopHoriz.Visible = True
            linRightVert.Visible = True
            linBottomHoriz.Visible = True
        End If
    Else
        BackColor = Ambient.BackColor
        lblValue.BackColor = Ambient.BackColor
        lblValue.ForeColor = mFontColor
        linLeftVert.Visible = False
        linTopHoriz.Visible = False
        linRightVert.Visible = False
        linBottomHoriz.Visible = False
    End If
    PropertyChanged "Pressed"
End Property

Public Property Get PressedColor() As OLE_COLOR
Attribute PressedColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    PressedColor = mPressedColor
End Property

Public Property Let PressedColor(ByVal RHS As OLE_COLOR)
    mPressedColor = RHS
    If mPressed Then lblValue.BackColor = RHS
    PropertyChanged "PressedColor"
End Property

Public Property Get Value() As Integer
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Data"
Attribute Value.VB_UserMemId = 0
    Value = mValue
End Property

Public Property Let Value(ByVal RHS As Integer)
    If 1 > RHS Or RHS > 31 Then RHS = 1
    mValue = RHS
    lblValue.Caption = CStr(RHS)
End Property

Private Sub lblValue_Click()
    RaiseEvent Click
End Sub

Private Sub mFont_FontChanged(ByVal PropertyName As String)
   Set lblValue.Font = mFont
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_Initialize()
    Set mFont = New StdFont
End Sub

Private Sub UserControl_InitProperties()
    BackColor = Ambient.BackColor
    Effect = ccdcEffectRaised
    Set Font = New StdFont
    FontColor = &HA00000
    FontPressedColor = vbButtonText
    LinesColor = vbButtonShadow
    PressedColor = vbButtonShadow
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_LostFocus()
    Pressed = False
End Sub

Private Sub UserControl_Resize()
    Dim PixX As Single
    Dim PixY As Single
    
    On Error Resume Next 'This is normally bad form, but Paint and Resize events are
                         'critical and there is no other graceful way to deal with an
                         'exception in here. We would trap and repair errors with
                         'fallback adjustments but there are really none to be made
                         'here.
    With Screen
        PixX = .TwipsPerPixelX
        PixY = .TwipsPerPixelY
    End With
    shpBorder.Move 0, 0, ScaleWidth, ScaleHeight
    With linLeftVert
        .X1 = PixX
        .Y1 = PixY
        .X2 = PixX
        .Y2 = ScaleHeight - 2 * PixY
    End With
    With linTopHoriz
        .X1 = PixX
        .Y1 = PixY
        .X2 = ScaleWidth - 2 * PixX
        .Y2 = PixY
    End With
    With linRightVert
        .X1 = ScaleWidth - 2 * PixX
        .Y1 = PixY
        .X2 = ScaleWidth - 2 * PixX
        .Y2 = ScaleHeight
    End With
    With linBottomHoriz
        .X1 = PixX
        .Y1 = ScaleHeight - 2 * PixY
        .X2 = ScaleWidth - 2 * PixX
        .Y2 = ScaleHeight - 2 * PixY
    End With
    lblValue.Move 4 * PixX, 4 * PixY, ScaleWidth - 8 * PixX, ScaleHeight - 8 * PixY
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        BackColor = .ReadProperty("BackColor", Ambient.BackColor)
        Effect = .ReadProperty("Effect", ccdcEffectRaised)
        Set Font = .ReadProperty("Font", New StdFont)
        FontColor = .ReadProperty("FontColor", &HA00000)
        FontPressedColor = .ReadProperty("FontPressedColor", vbButtonText)
        LinesColor = .ReadProperty("LinesColor", vbButtonShadow)
        PressedColor = .ReadProperty("PressedColor", vbButtonShadow)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "BackColor", BackColor, Ambient.BackColor
        .WriteProperty "Effect", Effect, ccdcEffectRaised
        .WriteProperty "Font", Font, New StdFont
        .WriteProperty "FontColor", FontColor, &HA00000
        .WriteProperty "FontPressedColor", FontPressedColor, vbButtonText
        .WriteProperty "LinesColor", LinesColor, vbButtonShadow
        .WriteProperty "PressedColor", PressedColor, vbButtonShadow
    End With
End Sub
